// generate an ASCII table for use in B256Encoder.java
//
#include <stdio.h>
#include <ctype.h>

// print an escape sequence, e.g. escape('a') prints "\\a"
//
void escape( int c)
{
  printf( "   \"\\\\%c\",", c);
}

int main( void)
{
  int i, j, c;

  for( i = 0; i < 32; ++i)
  {
    printf( "   ");

    for( j = 0; j < 8; ++j)
    {
      c = i*8 + j;

      if( c == '\\') // special cases

	printf( "  \"\\\\\\\\\",");	// "\\\\",

      else if( c == '"')

	printf( "    \"\\\"\",");	// "\"",  

      else if( c == ' ')

	escape('_');

      else if( c > 32 && c < 127)	// regular printable characters

	printf( "     \"%c\",", c);	// e.g. "a",

      else switch( c) // C99 escape characters and others
      {
	case '\a': escape('a'); break;
	case '\b': escape('b'); break;
	case '\f': escape('f'); break;
	case '\n': escape('n'); break;
	case '\r': escape('r'); break;
	case '\t': escape('t'); break;
	case '\v': escape('v'); break;

	default:   printf( " \"\\\\x%02x\",", c); break; // e.g. "\\xff",
      }
    }

    putchar( '\n');
  }

  return 0;
}
